## appstream 0.1

=== CMakeLists.txt ===
# CMakeLists for the Update-AppStream-Index Project
project(appstream-core)

cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)

set(CMAKE_BUILD_TYPE "Debug")

set(AS_VERSION_MAJOR  "0")
set(AS_VERSION_MINOR  "1")
set(AS_VERSION_PATCH  "0")
set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
set(APPSTREAM_LIB_API_LEVEL "0")

# Don't allow in-tree building
if(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
      message(STATUS "Please do an out-of-tree build:")
      message(STATUS "rm -f CMakeCache.txt && mkdir build && cd build; cmake .. && make")
      message(FATAL_ERROR "In-tree-build detected!")
endif(${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})

#
# Options
#
option(PROVIDER_APPSTREAM "Enable AppStream data provider" ON)
option(PROVIDER_DEBIAN_DEP11 "Enable DEP11 data provider" OFF)
option(PROVIDER_UBUNTU_APPINSTALL "Enable AppInstall data provider" OFF)
option(L18N "Enable localization" ON)
option(TESTS "Enable Unit Tests" OFF)

set(VALA_COMPILE_FLAGS "")

if(PROVIDER_APPSTREAM)
	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=APPSTREAM)
endif()
if(PROVIDER_DEBIAN_DEP11)
	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=DEBIAN_DEP11)
endif()
if(PROVIDER_UBUNTU_APPINSTALL)
	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=UBUNTU_APPINSTALL)
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX
    "/usr" CACHE PATH "Default install prefix" FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(XDG_APPS_INSTALL_DIR share/applications)

add_definitions(-DCMAKE_INSTALL_PREFIX="\"${CMAKE_INSTALL_PREFIX}\"")
add_definitions(-DCMAKE_INSTALL_LIBDIR="\"${CMAKE_INSTALL_LIBDIR}\"")

set(CMAKE_INSTALL_LIBDIR "lib/${CMAKE_LIBRARY_ARCHITECTURE}" CACHE PATH "Output directory for libraries")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/data/cmake/)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/data/cmake/vala)

message(STATUS "Compiling AppStream core modules version ${AS_VERSION}")

add_custom_target(distclean
  "make clean"
)

#
# l18n
#
find_package (Gettext REQUIRED)

#
# Default paths
#
set(INSTALL_DIR_BIN bin CACHE PATH "Installation directory for executables")
set(INSTALL_DIR_LIB lib/${CMAKE_LIBRARY_ARCHITECTURE} CACHE PATH "Installation directory for libraries")
set(INSTALL_DIR_LIBEXEC "${INSTALL_DIR_LIB}/appstream" CACHE PATH "Installation directory for executables use by a library")
set(INSTALL_DIR_INC include CACHE PATH "Installation directory for headers")
set(INSTALL_DIR_SYSCONF etc CACHE PATH "Installation directory for system configuration files")

#
# Configure files
#
set (PREFIXDIR "${CMAKE_INSTALL_PREFIX}")
set (DATADIR "${CMAKE_INSTALL_PREFIX}/share")
set (PKGDATADIR "${DATA_INSTALL_DIR}")
set (LIBDIR "${INSTALL_DIR_LIB}")
set (PKGLIBDIR "${INSTALL_DIR_LIBEXEC}")
set (GETTEXT_PACKAGE "update-appstream-index")
set (LOCALE_DIR "${DATADIR}/locale")
set (VERSION "${AS_VERSION}")
set (BUILDDIR "${CMAKE_BINARY_DIR}")

configure_file(config.h.in ${CMAKE_BINARY_DIR}/config.h)

#
# Enable/disable testing
#
if(TESTS)
	enable_testing()
endif(TESTS)

#
# Custom C flags
#
set (MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
option (DISABLE_MAINTAINER_CFLAGS "Disable maintainer CFlags" ON)
if (DISABLE_MAINTAINER_CFLAGS)
	set (MAINTAINER_CFLAGS "")
endif (DISABLE_MAINTAINER_CFLAGS)
add_definitions(${MAINTAINER_CFLAGS})

# Required to include config.h before all other units
add_definitions ("--include config.h")

#
# Validate Vala version
#
find_package(PkgConfig REQUIRED)
find_package(Vala REQUIRED)
include(${VALA_USE_FILE})
ensure_vala_version("0.16" MINIMUM)

add_subdirectory(src)
add_subdirectory(uai)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(docs)
if(TESTS)
	add_subdirectory(tests)
endif(TESTS)

=== data/CMakeLists.txt ===
# CMakeLists for UAI data directory

set(servicedir "${CMAKE_INSTALL_PREFIX}/${INSTALL_DIR_LIBEXEC}")

find_program (LC_INTLTOOL_MERGE intltool-merge)
mark_as_advanced (LC_INTLTOOL_MERGE)

if (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")

configure_file(org.freedesktop.AppStream.service.in
  "${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.AppStream.service"
  IMMEDIATE @ONLY
)

install(FILES org.freedesktop.AppStream.conf
	DESTINATION /etc/dbus-1/system.d/
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.AppStream.service
	DESTINATION share/dbus-1/system-services/
)

add_custom_target (merge-l10n ALL
	${LC_INTLTOOL_MERGE} -x ${CMAKE_SOURCE_DIR}/po
		${CMAKE_CURRENT_SOURCE_DIR}/org.freedesktop.appstream.policy.in
		${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.appstream.policy
	DEPENDS org.freedesktop.appstream.policy.in
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.appstream.policy
	DESTINATION share/polkit-1/actions/
)

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

add_xml_manpages(doc-man "appstream-index.1" "" "")

=== src/CMakeLists.txt ===
# CMakeLists for AppStream database shared lib

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 2.28 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(Xapian 1.2 REQUIRED)
find_package(GI REQUIRED)

set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")

set(AS_VERSION_LIBS "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}")

set(APPSTREAM_LIB_SOURCES settings.vala
		utils.vala
		app-info.vala
		database.vala
		menudir.vala
)

set(ASLIB_XAP_SOURCES xapian/database-common.hpp
		xapian/database-read.hpp
		xapian/database-read.cpp
		xapian/database-write.hpp
		xapian/database-write.cpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/xapian
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
		    ${XAPIAN_INCLUDE_DIR}
)

vala_precompile(aslib-precomp ASLIB_SRC_C ${APPSTREAM_LIB_SOURCES}
			PACKAGES config gio-2.0 posix as-xapian
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
				${CMAKE_CURRENT_SOURCE_DIR}/xapian
			GENERATE_INTERNAL_HEADER appstream_internal.h
			GENERATE_HEADER appstream.h
			COMPILE_FLAGS ${VALA_COMPILE_FLAGS}
				--gir=AppStream-${AS_VERSION_LIBS}.gir
				--library appstream
				--internal-vapi=appstream_internal.vapi.orig
)

find_program (SED_TOOL NAMES sed)
if (NOT SED_TOOL)
	message (FATAL_ERROR "Unable to find sed")
endif (NOT SED_TOOL)

# Workaround to fix header filename in internal vapi
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/appstream_internal.vapi
	COMMAND ${SED_TOOL}  "'s/\"appstream.h\"/\"appstream_internal.h\"/'" ${CMAKE_CURRENT_BINARY_DIR}/appstream_internal.vapi.orig ">" ${CMAKE_CURRENT_BINARY_DIR}/appstream_internal.vapi
	DEPENDS aslib-precomp ${CMAKE_CURRENT_BINARY_DIR}/appstream_internal.vapi.orig
)
add_custom_target(header_internal_fix DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/appstream_internal.vapi)

# Compile the introspection data
add_custom_target (gir-compile
	${INTROSPECTION_COMPILER}  "--shared-library=appstream" "--includedir=."
				"${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.gir"
				"-o" "${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.typelib"
	DEPENDS aslib-precomp
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(appstream SHARED ${ASLIB_SRC_C} ${ASLIB_XAP_SOURCES})
set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})

add_dependencies(appstream aslib-precomp)
add_dependencies (appstream header_internal_fix)
add_dependencies (appstream gir-compile)

target_link_libraries(appstream
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${XAPIAN_LIBRARIES}
)

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/appstream.pc.in ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc @ONLY)

install(TARGETS appstream DESTINATION ${INSTALL_DIR_LIB})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.vapi DESTINATION share/vala/vapi)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.h DESTINATION include)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/appstream.pc DESTINATION lib/pkgconfig/)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.gir DESTINATION share/gir-1.0/)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.typelib DESTINATION lib/girepository-1.0/)

=== tests/CMakeLists.txt ===
# CMakeLists for UAI Unit Tests

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)

link_libraries(${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/src
		${CMAKE_SOURCE_DIR}/src/xapian
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GIO2_INCLUDE_DIR}
		${LIBXML2_INCLUDE_DIR}
)

# Basic tests
vala_add_executable (uai-test-basics test-basics.vala
				BASE_DIR ${CMAKE_SOURCE_DIR}/src
				PACKAGES config gio-2.0 posix libxml-2.0 appstream_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)
add_test(basic-test uai-test-basics ${CMAKE_CURRENT_SOURCE_DIR})

set(UAI_SOURCES_BASE ../uai/uai-utils.vala
		../uai/data-provider.vala
)

# AppStream-XML provider tests
vala_add_executable (uai-test-appstream ${UAI_SOURCES_BASE} ../uai/data-providers/appstream-xml.vala test-appstreamxml.vala
				BASE_DIR ${CMAKE_SOURCE_DIR}/src
				PACKAGES config gio-2.0 posix libxml-2.0 appstream_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)
add_test(appstream-xml-test uai-test-appstream ${CMAKE_CURRENT_SOURCE_DIR})

# AppStream database (read) tests
vala_add_executable (uai-test-db-read test-database-read.vala
				BASE_DIR ${CMAKE_SOURCE_DIR}/src
				PACKAGES config gio-2.0 posix libxml-2.0 appstream_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)
add_test(appstream-db-read-test uai-test-db-read ${CMAKE_CURRENT_SOURCE_DIR})

=== uai/CMakeLists.txt ===
# CMakeLists for update-appstream-index
project(update-appstream-index)

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)
pkg_check_modules(POLKIT REQUIRED polkit-gobject-1>=0.104)

set(UAI_SOURCES uai.vala
		uai-utils.vala
		uai-engine.vala
		data-provider.vala
		data-providers/appstream-xml.vala
		data-providers/debian-dep11.vala
		data-providers/ubuntu-appinstall.vala
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
		    ${POLKIT_INCLUDE_DIR}
		    ${POLKIT_INCLUDE_DIRS}
		    ${LIBXML2_INCLUDE_DIR}
)

# Add the update-appstream-index daemon executable
vala_add_executable(update-appstream-index ${UAI_SOURCES}
			PACKAGES config glib-2.0 gio-2.0 posix libxml-2.0 polkit-gobject-1 appstream_internal
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)

add_dependencies(update-appstream-index_precompile appstream)

target_link_libraries(update-appstream-index
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${POLKIT_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

# Add the appstream-index client tool
vala_add_executable (appstream-index uai-client.vala
				PACKAGES config gio-2.0 posix
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
)

target_link_libraries(appstream-index
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
)

install(TARGETS update-appstream-index DESTINATION ${INSTALL_DIR_LIBEXEC})
install(TARGETS appstream-index DESTINATION ${INSTALL_DIR_BIN})

=== debian/changelog ===
appstream (0.1-1) unstable; urgency=low

  * Initial release (Closes: #689998)

 -- Matthias Klumpp <matthias@tenstral.net>  Mon, 08 Oct 2012 20:57:15 +0200

=== debian/control ===
Source: appstream
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <matthias@tenstral.net>
DM-Upload-Allowed: yes
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               intltool,
               libdbus-glib-1-dev,
               libgirepository1.0-dev (>= 1.32),
               libglib2.0-dev (>= 2.28),
               libpolkit-gobject-1-dev,
               libxapian-dev (>= 1.2.12),
               libxml2-dev (>= 2.8.0),
               valac (>= 0.16),
               xmlto
Standards-Version: 3.9.3
Homepage: http://distributions.freedesktop.org/wiki/AppStream
Vcs-Git: git://anonscm.debian.org/pkg-packagekit/appstream.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/appstream.git

Package: appstream-index
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: packagekit (>= 0.8.4)
Recommends: app-install-data
Description: Generator for application index
 AppStream is an initiative of cross-distro collaboration,
 which aims at creating an unified software metadata database,
 and also a centralized OCS (Open Collaboration Services)
 user-contributed content database.
 The AppStream database allows people to write application-centric
 software management tools easily.
 .
 This package provides tools to generate, maintain and
 access the AppStream database of installed applications.

Package: libappstream0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: appstream-index (= ${binary:Version})
Description: Library to acess the AppStream database
 AppStream is an initiative of cross-distro collaboration,
 which aims at creating an unified software metadata database,
 and also a centralized OCS (Open Collaboration Services)
 user-contributed content database.
 The AppStream database allows people to write application-centric
 software management tools easily.
 .
 This package contains a GObject-based library to access the
 database of installed applications.

Package: libappstream-dev
Architecture: any
Section: libdevel
Depends: libappstream0 (= ${binary:Version}),
         libglib2.0-dev (>= 2.28),
         ${misc:Depends}
Description: Library to acess the AppStream database (development files)
 AppStream is an initiative of cross-distro collaboration,
 which aims at creating an unified software metadata database,
 and also a centralized OCS (Open Collaboration Services)
 user-contributed content database.
 The AppStream database allows people to write application-centric
 software management tools easily.
 .
 This package contains development files necessary to develop
 software-manager which use the AppStream library.

Package: gir1.2-appstream
Architecture: any
Section: introspection
Depends: gir1.2-freedesktop (>= 1.32),
         gir1.2-glib-2.0 (>= 1.32),
         libappstream0 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to acess the AppStream database (introspection data)
 AppStream is an initiative of cross-distro collaboration,
 which aims at creating an unified software metadata database,
 and also a centralized OCS (Open Collaboration Services)
 user-contributed content database.
 The AppStream database allows people to write application-centric
 software management tools easily.
 .
 This package contains introspection data for the AppStream library.

=== debian/watch ===
version=3

http://www.freedesktop.org/software/appstream/AppStream-([\d\.]+)\.tar\.gz

## appstream 0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,13 @@
-# CMakeLists for the Update-AppStream-Index Project
-project(appstream-core)
+# CMakeLists for the AppStream Project
+project(appstream)
 
 cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)
 
 set(CMAKE_BUILD_TYPE "Debug")
 
 set(AS_VERSION_MAJOR  "0")
-set(AS_VERSION_MINOR  "1")
-set(AS_VERSION_PATCH  "0")
+set(AS_VERSION_MINOR  "3")
+set(AS_VERSION_PATCH  "1")
 set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
 set(APPSTREAM_LIB_API_LEVEL "0")
 
@@ -72,7 +72,7 @@
 set(INSTALL_DIR_LIB lib/${CMAKE_LIBRARY_ARCHITECTURE} CACHE PATH "Installation directory for libraries")
 set(INSTALL_DIR_LIBEXEC "${INSTALL_DIR_LIB}/appstream" CACHE PATH "Installation directory for executables use by a library")
 set(INSTALL_DIR_INC include CACHE PATH "Installation directory for headers")
-set(INSTALL_DIR_SYSCONF etc CACHE PATH "Installation directory for system configuration files")
+set(INSTALL_DIR_SYSCONF /etc CACHE PATH "Installation directory for system configuration files")
 
 #
 # Configure files
@@ -118,7 +118,7 @@
 ensure_vala_version("0.16" MINIMUM)
 
 add_subdirectory(src)
-add_subdirectory(uai)
+add_subdirectory(client)
 add_subdirectory(data)
 add_subdirectory(po)
 add_subdirectory(docs)

=== client/CMakeLists.txt ===
# CMakeLists for appstream-index
project(appstream-index)

find_package(Vala REQUIRED)
include("${VALA_USE_FILE}")

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
find_package(LibXml2 REQUIRED)
find_library(M_LIB m)
pkg_check_modules(POLKIT REQUIRED polkit-gobject-1>=0.104)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
)

# Add the appstream-index client tool
vala_add_executable (appstream-index appstream-index.vala
				PACKAGES config gio-2.0 posix appstream_internal
				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)

target_link_libraries(appstream-index
		${M_LIB}
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		appstream
)

install(TARGETS appstream-index DESTINATION ${INSTALL_DIR_BIN})

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,10 @@
 configure_file(org.freedesktop.AppStream.service.in
   "${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.AppStream.service"
   IMMEDIATE @ONLY
+)
+
+install(FILES appstream.conf
+	DESTINATION ${INSTALL_DIR_SYSCONF}
 )
 
 install(FILES org.freedesktop.AppStream.conf
@@ -33,3 +37,7 @@
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.appstream.policy
 	DESTINATION share/polkit-1/actions/
 )
+
+install(FILES categories.xml
+	DESTINATION share/app-info/
+)

=== docs/CMakeLists.txt ===
# CMakeLists for documentation

find_program (XMLTO xmlto)
mark_as_advanced (XMLTO)
if (XMLTO STREQUAL "")
	message (FATAL_ERROR "Xmlto was not found! Please install it to continue!")
endif (XMLTO STREQUAL "")

include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)

add_xml_manpages(doc-man "appstream-index.1" "" "")

if (DOCUMENTATION)
	# find documentation tools
	find_program (VALADOC valadoc)
	mark_as_advanced (VALADOC)
	if (VALADOC STREQUAL "")
		message (FATAL_ERROR "valadoc was not found! Please install Valadoc to continue!")
	endif (VALADOC STREQUAL "")
	find_program(GTKDOC_SCAN_EXE gtkdoc-scan PATH "${GLIB_PREFIX}/bin")
	if(NOT GTKDOC_SCAN_EXE)
		message(FATAL_ERROR "gtkdoc not found")
	endif(NOT GTKDOC_SCAN_EXE)

	find_path (SYSTEM_VAPI_DIR
		NAMES glib-2.0.vapi
		HINTS "/usr/share/vala-0.??/vapi" "/usr/share/vala")
	# ugly hack to help valadoc finding vapi files
	string (SUBSTRING ${VALA_VERSION} 0 4 VALA_VERSION_SHORT)
	set (SYSTEM_VAPI_DIR "${CMAKE_INSTALL_PREFIX}/share/vala-${VALA_VERSION_SHORT}/vapi")

	# find public library sources
	file (GLOB APPSTREAM_LIB_SOURCES "${CMAKE_SOURCE_DIR}/src/*.vala")

	add_custom_target (documentation
			COMMAND "valadoc" "--force" "-b" "${CMAKE_SOURCE_DIR}/src" "-o" "${CMAKE_SOURCE_DIR}/docs/api"
			"--vapidir=${CMAKE_SOURCE_DIR}/vapi" "--vapidir=${SYSTEM_VAPI_DIR}"
			"--vapidir=${CMAKE_SOURCE_DIR}/src/xapian"
			"-X" "${CMAKE_BINARY_DIR}/src/appstream.h" "-X" "-l"
			"-X" "${CMAKE_BINARY_DIR}/src/libappstream.so.${AS_VERSION_LIBS}"
			"--doclet" "gtkdoc"
			"--pkg=config" "--pkg=gio-2.0" "--pkg=libxml-2.0" "--pkg=as-xapian"
			"--package-name=appstream"
			"--package-version=${AS_VERSION_LIBS}"
			"--importdir=${CMAKE_SOURCE_DIR}/docs"
			${APPSTREAM_LIB_SOURCES}
			VERBATIM)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/api/html)
	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/api/xml)
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,16 +7,23 @@
 pkg_check_modules(GIO2 REQUIRED gio-2.0)
 find_package(Xapian 1.2 REQUIRED)
 find_package(GI REQUIRED)
+find_package(LibXml2 REQUIRED)
+find_library(M_LIB m)
+pkg_check_modules(POLKIT REQUIRED polkit-gobject-1>=0.104)
 
 set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")
 
-set(AS_VERSION_LIBS "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}")
+set(AS_VERSION_LIBS "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}" CACHE INTERNAL "LibAppStream combined version number")
+
+# include the daemon
+add_subdirectory(uai-service)
 
 set(APPSTREAM_LIB_SOURCES settings.vala
 		utils.vala
 		app-info.vala
 		database.vala
 		menudir.vala
+		screenshot-service.vala
 )
 
 set(ASLIB_XAP_SOURCES xapian/database-common.hpp
@@ -24,6 +31,8 @@
 		xapian/database-read.cpp
 		xapian/database-write.hpp
 		xapian/database-write.cpp
+		xapian/database-vala.hpp
+		xapian/database-vala.cpp
 )
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/xapian
@@ -31,11 +40,12 @@
 		    ${CMAKE_BINARY_DIR}/src
 		    ${GLIB2_INCLUDE_DIR}
 		    ${GIO2_INCLUDE_DIR}
+		    ${LIBXML2_INCLUDE_DIR}
 		    ${XAPIAN_INCLUDE_DIR}
 )
 
 vala_precompile(aslib-precomp ASLIB_SRC_C ${APPSTREAM_LIB_SOURCES}
-			PACKAGES config gio-2.0 posix as-xapian
+			PACKAGES config gio-2.0 posix libxml-2.0 as-xapian
 			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
 				${CMAKE_CURRENT_SOURCE_DIR}/xapian
 			GENERATE_INTERNAL_HEADER appstream_internal.h
@@ -71,12 +81,13 @@
 set_target_properties(appstream PROPERTIES VERSION ${AS_VERSION} SOVERSION ${APPSTREAM_LIB_API_LEVEL})
 
 add_dependencies(appstream aslib-precomp)
-add_dependencies (appstream header_internal_fix)
-add_dependencies (appstream gir-compile)
+add_dependencies(appstream header_internal_fix)
+add_dependencies(appstream gir-compile)
 
 target_link_libraries(appstream
 		${GLIB2_LIBRARIES}
 		${GIO2_LIBRARIES}
+		${LIBXML2_LIBRARIES}
 		${XAPIAN_LIBRARIES}
 )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -32,12 +32,12 @@
 )
 add_test(basic-test uai-test-basics ${CMAKE_CURRENT_SOURCE_DIR})
 
-set(UAI_SOURCES_BASE ../uai/uai-utils.vala
-		../uai/data-provider.vala
+set(UAI_SOURCES_BASE ../src/uai-service/uai-utils.vala
+		../src/uai-service/data-provider.vala
 )
 
 # AppStream-XML provider tests
-vala_add_executable (uai-test-appstream ${UAI_SOURCES_BASE} ../uai/data-providers/appstream-xml.vala test-appstreamxml.vala
+vala_add_executable (uai-test-appstream ${UAI_SOURCES_BASE} ../src/uai-service/data-providers/appstream-xml.vala test-appstreamxml.vala
 				BASE_DIR ${CMAKE_SOURCE_DIR}/src
 				PACKAGES config gio-2.0 posix libxml-2.0 appstream_internal
 				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src

=== src/uai-service/CMakeLists.txt ===
# CMakeLists for update-appstream-index

set(UAI_SOURCES uai.vala
		uai-utils.vala
		uai-engine.vala
		data-provider.vala
		data-providers/appstream-xml.vala
		data-providers/debian-dep11.vala
		data-providers/ubuntu-appinstall.vala
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
		    ${CMAKE_BINARY_DIR}
		    ${CMAKE_BINARY_DIR}/src
		    ${GLIB2_INCLUDE_DIR}
		    ${GIO2_INCLUDE_DIR}
		    ${POLKIT_INCLUDE_DIR}
		    ${POLKIT_INCLUDE_DIRS}
		    ${LIBXML2_INCLUDE_DIR}
)

# Add the update-appstream-index daemon executable
vala_add_executable(update-appstream-index ${UAI_SOURCES}
			PACKAGES config glib-2.0 gio-2.0 posix libxml-2.0 polkit-gobject-1 appstream_internal
			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
)

add_dependencies(update-appstream-index_precompile appstream)

target_link_libraries(update-appstream-index
		${GLIB2_LIBRARIES}
		${GIO2_LIBRARIES}
		${POLKIT_LIBRARIES}
		${LIBXML2_LIBRARIES}
		appstream
)

install(TARGETS update-appstream-index DESTINATION ${INSTALL_DIR_LIBEXEC})

=== debian/changelog ===
appstream (0.3.1-3) unstable; urgency=low

  * Tighten dependency on libappstream0 (Closes: #714513)
  * Add AppStream app-info dir to trigger
  * Install missing config file

 -- Matthias Klumpp <mak@debian.org>  Thu, 11 Jul 2013 18:15:25 +0200

appstream (0.3.1-2) unstable; urgency=low

  * Don't automatically refresh cache after installation (Closes: #703513)

 -- Matthias Klumpp <mak@debian.org>  Sat, 29 Jun 2013 21:28:52 +0200

appstream (0.3.1-1) unstable; urgency=low

  * Update debian/watch file
  * New upstream release: 0.3.1
  * Drop all patches: Applied upstream

 -- Matthias Klumpp <mak@debian.org>  Fri, 28 Jun 2013 17:52:08 +0200

appstream (0.2.0-2) unstable; urgency=low

  * Fix debian/watch file
  * Fix database path
  * Add dependency on PolicyKit (Closes: #703513)
  * db_missing.patch: Create database if it is missing
  * uai_failsafe.patch: Make UAI a bit more failsafe

 -- Matthias Klumpp <mak@debian.org>  Thu, 21 Mar 2013 14:04:45 +0100

appstream (0.2.0-1) unstable; urgency=low

  * New upstream release: 0.2
  * Fix override disparity
  * Change mail to my Debian address

 -- Matthias Klumpp <mak@debian.org>  Tue, 19 Mar 2013 21:42:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: appstream
 Section: admin
 Priority: optional
-Maintainer: Matthias Klumpp <matthias@tenstral.net>
-DM-Upload-Allowed: yes
+Maintainer: Matthias Klumpp <mak@debian.org>
 Build-Depends: cmake (>= 2.8),
                debhelper (>= 9.0.0),
                intltool,
@@ -14,14 +13,16 @@
                libxml2-dev (>= 2.8.0),
                valac (>= 0.16),
                xmlto
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://distributions.freedesktop.org/wiki/AppStream
 Vcs-Git: git://anonscm.debian.org/pkg-packagekit/appstream.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/appstream.git
 
 Package: appstream-index
 Architecture: any
-Depends: ${misc:Depends},
+Depends: libappstream0 (>= ${binary:Version}),
+         policykit-1,
+         ${misc:Depends},
          ${shlibs:Depends}
 Suggests: packagekit (>= 0.8.4)
 Recommends: app-install-data
@@ -38,6 +39,7 @@
 
 Package: libappstream0
 Architecture: any
+Section: libs
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},

## appstream 0.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 set(CMAKE_BUILD_TYPE "Debug")
 
 set(AS_VERSION_MAJOR  "0")
-set(AS_VERSION_MINOR  "3")
-set(AS_VERSION_PATCH  "1")
+set(AS_VERSION_MINOR  "4")
+set(AS_VERSION_PATCH  "0")
 set(AS_VERSION "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}.${AS_VERSION_PATCH}")
 set(APPSTREAM_LIB_API_LEVEL "0")
 
@@ -21,22 +21,18 @@
 #
 # Options
 #
-option(PROVIDER_APPSTREAM "Enable AppStream data provider" ON)
 option(PROVIDER_DEBIAN_DEP11 "Enable DEP11 data provider" OFF)
 option(PROVIDER_UBUNTU_APPINSTALL "Enable AppInstall data provider" OFF)
 option(L18N "Enable localization" ON)
 option(TESTS "Enable Unit Tests" OFF)
 
-set(VALA_COMPILE_FLAGS "")
+set(VALA_COMPILE_FLAGS "--target-glib=2.36")
 
-if(PROVIDER_APPSTREAM)
-	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=APPSTREAM)
-endif()
 if(PROVIDER_DEBIAN_DEP11)
-	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=DEBIAN_DEP11)
+	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} "--define=DEBIAN_DEP11")
 endif()
 if(PROVIDER_UBUNTU_APPINSTALL)
-	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} --define=UBUNTU_APPINSTALL)
+	set(VALA_COMPILE_FLAGS ${VALA_COMPILE_FLAGS} "--define=UBUNTU_APPINSTALL")
 endif()
 
 if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
@@ -82,7 +78,7 @@
 set (PKGDATADIR "${DATA_INSTALL_DIR}")
 set (LIBDIR "${INSTALL_DIR_LIB}")
 set (PKGLIBDIR "${INSTALL_DIR_LIBEXEC}")
-set (GETTEXT_PACKAGE "update-appstream-index")
+set (GETTEXT_PACKAGE "appstream")
 set (LOCALE_DIR "${DATADIR}/locale")
 set (VERSION "${AS_VERSION}")
 set (BUILDDIR "${CMAKE_BINARY_DIR}")
@@ -99,12 +95,15 @@
 #
 # Custom C flags
 #
-set (MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
+set (MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wuninitialized -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self")
 option (DISABLE_MAINTAINER_CFLAGS "Disable maintainer CFlags" ON)
 if (DISABLE_MAINTAINER_CFLAGS)
 	set (MAINTAINER_CFLAGS "")
 endif (DISABLE_MAINTAINER_CFLAGS)
 add_definitions(${MAINTAINER_CFLAGS})
+
+# we do always enable this to never run into the missing-include-trap with Vala again
+add_definitions("-Werror=implicit-function-declaration")
 
 # Required to include config.h before all other units
 add_definitions ("--include config.h")

=== client/CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,7 @@
 
 find_package(GLIB2 REQUIRED)
 pkg_check_modules(GIO2 REQUIRED gio-2.0)
-find_package(LibXml2 REQUIRED)
 find_library(M_LIB m)
-pkg_check_modules(POLKIT REQUIRED polkit-gobject-1>=0.104)
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}
 		    ${CMAKE_BINARY_DIR}
@@ -19,8 +17,10 @@
 
 # Add the appstream-index client tool
 vala_add_executable (appstream-index appstream-index.vala
-				PACKAGES config gio-2.0 posix appstream_internal
+				PACKAGES config appstream gio-2.0 posix
 				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src
+				COMPILE_FLAGS ${VALA_COMPILE_FLAGS}
+					--pkg appstream # somehow we need to explicitly define that, PACKAGES directive does not always work
 )
 
 target_link_libraries(appstream-index

=== data/CMakeLists.txt ===
# CMakeLists for UAI data directory

set(servicedir "${CMAKE_INSTALL_PREFIX}/${INSTALL_DIR_LIBEXEC}")

find_program (LC_INTLTOOL_MERGE intltool-merge)
mark_as_advanced (LC_INTLTOOL_MERGE)

if (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_MERGE STREQUAL "LC_INTLTOOL_MERGE-NOTFOUND")

install(FILES appstream.conf
	DESTINATION ${INSTALL_DIR_SYSCONF}
)

install(FILES categories.xml
	DESTINATION share/app-info/
)

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,60 @@
 
 include (${CMAKE_SOURCE_DIR}/data/cmake/documentation.cmake)
 
-add_xml_manpages(doc-man "appstream-index.1" "" "")
+add_xml_manpages(doc-man "sources/man/appstream-index.1" "" "")
 
 if (DOCUMENTATION)
+	#########################
+	# General project documentation
+	find_program (PUBLICAN publican)
+	mark_as_advanced (PUBLICAN)
+	if (PUBLICAN STREQUAL "")
+		message (FATAL_ERROR "Publican was not found! Please install the it to continue!")
+	endif (PUBLICAN STREQUAL "")
+
+	# we need to assemble our documentation build-directory before we can built it
+	add_custom_target (assemble-docs
+		COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/prepare-docbuild.sh" "source_dir=${CMAKE_CURRENT_SOURCE_DIR}" "build_dir=${CMAKE_BINARY_DIR}/docbuild"
+		DEPENDS "publican.cfg"
+			"sources/"
+			"${CMAKE_BINARY_DIR}/docbuild/"
+			"${CMAKE_BINARY_DIR}/src/libappstream.so"
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+		VERBATIM
+	)
+
+	# the actual target to build all documentation
+	add_custom_target (documentation
+		COMMAND ${PUBLICAN} "build" "--langs=en-US" "--publish" "--formats=html"
+		DEPENDS "publican.cfg"
+			"${CMAKE_BINARY_DIR}/docbuild/publican.cfg"
+			assemble-docs
+			api-docs
+		WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/docbuild/
+	)
+	add_custom_command (OUTPUT "${CMAKE_BINARY_DIR}/docbuild/"
+			COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_BINARY_DIR}/docbuild"
+			VERBATIM
+	)
+
+	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_SOURCE_DIR}/html)
+	set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_BINARY_DIR}/docbuild)
+
+	# a target to export documentation html to the source tree (useful when building the tarballs)
+	add_custom_target (documentation-htmlexport
+		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_BINARY_DIR}/docbuild/AppStream-Docs/en-US/html/" "${CMAKE_CURRENT_SOURCE_DIR}/html"
+		DEPENDS documentation
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+	)
+	add_custom_command(
+		TARGET documentation-htmlexport POST_BUILD
+		COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/api/html" "${CMAKE_CURRENT_SOURCE_DIR}/html/api/html"
+		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+	)
+
+	#########################
+	# API documentation
+
 	# find documentation tools
 	find_program (VALADOC valadoc)
 	mark_as_advanced (VALADOC)
@@ -31,15 +82,17 @@
 
 	# find public library sources
 	file (GLOB APPSTREAM_LIB_SOURCES "${CMAKE_SOURCE_DIR}/src/*.vala")
+	file (GLOB tmp "${CMAKE_SOURCE_DIR}/src/data-providers/*.vala")
+	set(APPSTREAM_LIB_SOURCES ${APPSTREAM_LIB_SOURCES} ${tmp})
 
-	add_custom_target (documentation
+	add_custom_target (api-docs
 			COMMAND "valadoc" "--force" "-b" "${CMAKE_SOURCE_DIR}/src" "-o" "${CMAKE_SOURCE_DIR}/docs/api"
 			"--vapidir=${CMAKE_SOURCE_DIR}/vapi" "--vapidir=${SYSTEM_VAPI_DIR}"
 			"--vapidir=${CMAKE_SOURCE_DIR}/src/xapian"
 			"-X" "${CMAKE_BINARY_DIR}/src/appstream.h" "-X" "-l"
 			"-X" "${CMAKE_BINARY_DIR}/src/libappstream.so.${AS_VERSION_LIBS}"
 			"--doclet" "gtkdoc"
-			"--pkg=config" "--pkg=gio-2.0" "--pkg=libxml-2.0" "--pkg=as-xapian"
+			"--pkg=config" "--pkg=gio-2.0" "--pkg=libxml-2.0" "--pkg=posix" "--pkg=as-xapian"
 			"--package-name=appstream"
 			"--package-version=${AS_VERSION_LIBS}"
 			"--importdir=${CMAKE_SOURCE_DIR}/docs"

=== po/CMakeLists.txt ===
# CMakeLists for AppStream-Core localisation

find_program (LC_INTLTOOL_UPDATE intltool-update)
mark_as_advanced (LC_INTLTOOL_UPDATE)

find_package (Gettext REQUIRED)

if (LC_INTLTOOL_UPDATE STREQUAL "")
	message (FATAL_ERROR "Intltool was not found! Please install it to continue!")
endif (LC_INTLTOOL_UPDATE STREQUAL "")

set(LPKNAME "appstream")

add_custom_target (l10n-update
	${LC_INTLTOOL_UPDATE} -p -g "${LPKNAME}"
	DEPENDS POTFILES.in
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file (GLOB _translations ${CMAKE_CURRENT_SOURCE_DIR}/*.po)
        gettext_create_translations (${LPKNAME}.pot
				     ALL ${_translations}
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -3,27 +3,31 @@
 find_package(Vala REQUIRED)
 include("${VALA_USE_FILE}")
 
-find_package(GLIB2 2.28 REQUIRED)
+find_package(GLIB2 2.36 REQUIRED)
 pkg_check_modules(GIO2 REQUIRED gio-2.0)
 find_package(Xapian 1.2 REQUIRED)
 find_package(GI REQUIRED)
 find_package(LibXml2 REQUIRED)
 find_library(M_LIB m)
-pkg_check_modules(POLKIT REQUIRED polkit-gobject-1>=0.104)
 
 set (srcdir ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "Source dir")
 
 set(AS_VERSION_LIBS "${AS_VERSION_MAJOR}.${AS_VERSION_MINOR}" CACHE INTERNAL "LibAppStream combined version number")
 
-# include the daemon
-add_subdirectory(uai-service)
-
 set(APPSTREAM_LIB_SOURCES settings.vala
+		# utils
 		utils.vala
+		# public API
 		app-info.vala
 		database.vala
 		menudir.vala
 		screenshot-service.vala
+		# internal stuff to build the database
+		database-builder.vala
+		data-provider.vala
+		data-providers/appstream-xml.vala
+		data-providers/debian-dep11.vala
+		data-providers/ubuntu-appinstall.vala
 )
 
 set(ASLIB_XAP_SOURCES xapian/database-common.hpp
@@ -44,6 +48,10 @@
 		    ${XAPIAN_INCLUDE_DIR}
 )
 
+add_definitions("-DI_KNOW_THE_PACKAGEKIT_GLIB2_API_IS_SUBJECT_TO_CHANGE"
+	"-DI_KNOW_THE_PACKAGEKIT_PLUGIN_API_IS_SUBJECT_TO_CHANGE"
+)
+
 vala_precompile(aslib-precomp ASLIB_SRC_C ${APPSTREAM_LIB_SOURCES}
 			PACKAGES config gio-2.0 posix libxml-2.0 as-xapian
 			VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi
@@ -55,6 +63,11 @@
 				--library appstream
 				--internal-vapi=appstream_internal.vapi.orig
 )
+
+# ensure that the GI compiler has been found (apparently, the automatic tests fail on some machines)
+if (INTROSPECTION_COMPILER STREQUAL "")
+  message(FATAL_ERROR "GObject-Introspection was not found! Please install it to continue.")
+endif()
 
 find_program (SED_TOOL NAMES sed)
 if (NOT SED_TOOL)
@@ -100,3 +113,5 @@
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.gir DESTINATION share/gir-1.0/)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/AppStream-${AS_VERSION_LIBS}.typelib DESTINATION lib/girepository-1.0/)
 
+# include the PackageKit plugin
+add_subdirectory(pk-plugin)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -32,12 +32,8 @@
 )
 add_test(basic-test uai-test-basics ${CMAKE_CURRENT_SOURCE_DIR})
 
-set(UAI_SOURCES_BASE ../src/uai-service/uai-utils.vala
-		../src/uai-service/data-provider.vala
-)
-
 # AppStream-XML provider tests
-vala_add_executable (uai-test-appstream ${UAI_SOURCES_BASE} ../src/uai-service/data-providers/appstream-xml.vala test-appstreamxml.vala
+vala_add_executable (uai-test-appstream ${UAI_SOURCES_BASE} test-appstreamxml.vala
 				BASE_DIR ${CMAKE_SOURCE_DIR}/src
 				PACKAGES config gio-2.0 posix libxml-2.0 appstream_internal
 				VAPI_DIRS ${CMAKE_SOURCE_DIR}/vapi ${CMAKE_BINARY_DIR}/src

=== src/pk-plugin/CMakeLists.txt ===
# CMakeLists for AppStream PackageKit PlugIn

find_package(GLIB2 REQUIRED)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(PACKAGEKIT REQUIRED packagekit-glib2)
pkg_check_modules(PACKAGEKIT_PLUGIN REQUIRED packagekit-plugin)

set(PK_APPSTREAM_SOURCES pk-plugin-appstream.c
)

add_library(pk_plugin_appstream MODULE ${PK_APPSTREAM_SOURCES})

target_link_libraries(pk_plugin_appstream
		${M_LIB}
		${GIO2_LIBRARIES}
		${PACKAGEKIT_LIBRARIES}
		${PACKAGEKIT_PLUGIN_LIBRARIES}
		appstream
)

include_directories(${CMAKE_BINARY_DIR}
		${CMAKE_BINARY_DIR}/src
		${CMAKE_CURRENT_SOURCE_DIR}
		${GLIB2_INCLUDE_DIR}
		${GIO2_INCLUDE_DIR}
		${PACKAGEKIT_INCLUDE_DIRS}
		${PACKAGEKIT_PLUGIN_INCLUDE_DIRS}
)

install(TARGETS pk_plugin_appstream DESTINATION ${INSTALL_DIR_LIB}/packagekit-plugins)

=== debian/changelog ===
appstream (0.4.0-1) unstable; urgency=low

  * New upstream release: 0.4.0
  * Update descriptions
  * Install pc-file into multiarch libdir
  * Touch AppStream dirs after update, so we schedule a cache rebuild

 -- Matthias Klumpp <mak@debian.org>  Sun, 20 Oct 2013 18:40:26 +0200

=== debian/control ===
Source: appstream
Section: admin
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9.0.0),
               intltool,
               libdbus-glib-1-dev,
               libgirepository1.0-dev (>= 1.32),
               libglib2.0-dev (>= 2.28),
               libpackagekit-glib2-dev (>= 0.8.10),
               libpolkit-gobject-1-dev,
               libxapian-dev (>= 1.2.12),
               libxml2-dev (>= 2.8.0),
               valac (>= 0.20),
               xmlto
Standards-Version: 3.9.4
Homepage: http://distributions.freedesktop.org/wiki/AppStream
Vcs-Git: git://anonscm.debian.org/pkg-packagekit/appstream.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/appstream.git

Package: appstream-index
Architecture: any
Depends: libappstream0 (>= ${binary:Version}),
         packagekit (>= 0.8.10),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: app-install-data
Description: Application index generator
 AppStream is a cross-distribution effort for building application-
 management tools.
 It provides specifications for an unified application metadata database,
 screenshot services and various other things needed to create user-friendly
 application-centers.
 .
 This package provides tools to generate, maintain and
 access the AppStream database of installed and available applications.

Package: libappstream0
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: appstream-index (= ${binary:Version})
Description: Library to access AppStream services
 AppStream is a cross-distribution effort for building application-
 management tools.
 It provides specifications for an unified application metadata database,
 screenshot services and various other things needed to create user-friendly
 application-centers.
 .
 This package contains a GObject-based library to access AppStream
 services, like the application metadata database.

Package: libappstream-dev
Architecture: any
Section: libdevel
Depends: libappstream0 (= ${binary:Version}),
         libglib2.0-dev (>= 2.28),
         ${misc:Depends}
Description: Library to access AppStream services (development files)
 AppStream is a cross-distribution effort for building application-
 management tools.
 It provides specifications for an unified application metadata database,
 screenshot services and various other things needed to create user-friendly
 application-centers.
 .
 This package contains development files necessary to develop
 application-management tools which use the AppStream library.

Package: gir1.2-appstream
Architecture: any
Section: introspection
Depends: gir1.2-freedesktop (>= 1.32),
         gir1.2-glib-2.0 (>= 1.32),
         libappstream0 (= ${binary:Version}),
         ${misc:Depends}
Description: Library to access AppStream services (introspection data)
 AppStream is a cross-distribution effort for building application-
 management tools.
 It provides specifications for an unified application metadata database,
 screenshot services and various other things needed to create user-friendly
 application-centers.
 .
 This package contains introspection data for the AppStream library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

AS_CONFIGURE_ARGS = -DPROVIDER_UBUNTU_APPINSTALL=ON


# Define install target dir
INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(AS_CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

override_dh_install:
	dh_install --list-missing
